/* $Id: iss_audit.h 606 2008-08-15 08:39:26Z gloomy $ */

#ifndef _ISS_AUDIT_H_INCLUDED
#define _ISS_AUDIT_H_INCLUDED

#include <stdio.h>		/* For FILE */
#include <sys/types.h>		/* For pid_t */

#include <parsec/parsec.h>
#include <parsec/parsec_aud.h>
#include <parsec/aud_db.h>
#include <linux/kernel_audit.h>
#include <linux/file_audit.h>

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************
 *           WORKING WITH CONFIG FILE              *
 ***************************************************/

#define AUDIT_DEFAULT_FILE "/etc/security/audit"

/* For compatibility with <path.h>.
 * You can use this macro, or macro
 * above, without difference.
 */
#define _PATH_AUDIT       AUDIT_DEFAULT_FILE

/*
#define AUDIT_TYPE_USER   0x01
#define AUDIT_TYPE_GROUP  0x02
#define AUDIT_TYPE_OTHER  0x04
#define AUDIT_TYPE_ANY    (AUDIT_TYPE_USER | AUDIT_TYPE_GROUP | AUDIT_TYPE_OTHER)
*/

//	typedef __u32 audit_ps_t;

//	struct audit_entry {
//		int type;	/* The entry type: AUDIT_ENTRY_USER, .._GROUP, or .._OTHER. */
//		char *name;	/* User's or group's name. For "other" entry this field is empty. */
//		audit_ps_t succ;	/* Audit these events in case of success. */
//		audit_ps_t fail;	/* Audit these events in case of failure. */
//	};

/*
 * Function "setaudent" opens, 
 * function "endaudent" closes and
 * function "getaudent" reads audit_entry
 * structure from AUDIT_DEFAULT_FILE.
 */
/*	extern int setaudent(int for_types);
	extern void endaudent(void);
	extern struct audit_entry *getaudent(void);
*/
/*
 * Function "fgetaudent" reads
 * next noncomment string from file "f" 
 * and returns pointer to corresponding structure 
 * "audit_entry".
 * In case of error returns NULL-pointer:
 */
//	extern struct audit_entry *fgetaudent(FILE * f);

/* 
 * Function "fputaudent" adds
 * to file "f" formatted string according to "data".
 */
//	extern void fputaudent(FILE * f, const struct audit_entry *data);

/*
 * Function "putaudent" write audit_entry structure
 * "data" to AUDIT_DEFAULT_FILE. If entry with
 * type "data->type" and name "data->name" already
 * exists in this file, it replaced with new values.
 * If no such entry, it added.
 */
//	extern int putaudent(const struct audit_entry *data);

/* 
 * Function "getaudtype" gets data from AUDIT_DEFAULT_FILE
 * corresponded to entry of type "type" with name "name".
 * If there is no such entry in the file, NULL pointer returned.
 *
 * For "type" AUDIT_ENTRY_OTHER variable "name" is ignored.
 */
//	extern struct audit_entry *getaudtype(int type, const char *name);

/*
 * Remove entry of type "type" with name "name".
 * On success 0 returned. In case of no such entry
 * in AUDIT_DEFAULT_FILE, function returns 0, i. e.
 * success.
 */
//	extern int rmaudtype(int type, const char *name);

/***************************************************
 *           WORKING WITH PROCESSES                *
 ***************************************************/
	extern int setaud(audit_ps_t succ, audit_ps_t fail);
	extern int psetaud(pid_t pid, audit_ps_t succ, audit_ps_t fail);
	extern int getaud(audit_ps_t * succbuf, audit_ps_t * failbuf);
	extern int pgetaud(pid_t pid, audit_ps_t * succbuf,
			   audit_ps_t * failbuf);

/***************************************************
 *           WORKING WITH FILE SYSTEM              *
 ***************************************************/
	extern int chaud(const char *fname, const file_audit_header_t * data,
			 int size);
	extern int fchaud(int fd, const file_audit_header_t * data, int size);
	extern int stataud(const char *fname, file_audit_header_t * data,
			   int *size);
	extern int fstataud(int fd, file_audit_header_t * data, int *size);

#ifdef __cplusplus
}
#endif

#endif				/* _ISS_AUDIT_H_INCLUDED */
