/* $Id: iss_caps.h 606 2008-08-15 08:39:26Z gloomy $ */

#ifndef _ISS_CAPS_H_INCLUDED
#define _ISS_CAPS_H_INCLUDED

#include <stdio.h>		/* For FILE */
#include <sys/types.h>		/* For pid_t */
#include <linux/capability.h>

#include <parsec/parsec.h>
#include <parsec/parsec_cap.h>
#include <parsec/cap_db.h>
#include <linux/file_caps.h>	/* For file caps */
#include <linux/mcbc_cap.h>	/* For caps */

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************
 *           WORKING WITH CONFIG FILE              *
 ***************************************************/
#define DEFAULT_CAPS_FILE  "/etc/security/capabilities"

/* For compatibility with <path.h>.
 * You can use this macro, or macro
 * above, without difference.
 */
#define _PATH_CAPABILITIES  DEFAULT_CAPS_FILE

/*
	struct caps {
		char *name;
		__u32 mcbc_caps;
		__u32 linux_caps;
	};
*/
/* mcbc_caps field was renamed to parsec_caps */
#define mcbc_caps parsec_caps

/*
	extern int setcapent(void);
	extern void endcapent(void);
	extern struct caps *getcapent(void);

	extern struct caps *getcapnam(const char *name);
	extern int putcapent(const struct caps *data);

	extern struct caps *fgetcapent(FILE * f);
	extern void fputcapent(FILE * f, const struct caps *data);

	extern int rmcapnam(const char *name);
*/
/***************************************************
 *           WORKING WITH PROCESSES                *
 ***************************************************/
//	typedef struct __user_cap_data_struct linux_caps_t;

	extern int setcaps(const linux_caps_t * linux_caps,
			   const mcbc_caps_t * mcbc_caps);
	extern int psetcaps(pid_t pid, const linux_caps_t * linux_caps,
			    const mcbc_caps_t * mcbc_caps);
	extern int getcaps(linux_caps_t * linux_caps, mcbc_caps_t * mcbc_caps);
	extern int pgetcaps(pid_t pid, linux_caps_t * linux_caps,
			    mcbc_caps_t * mcbc_caps);

/***************************************************
 *           WORKING WITH FILE SYSTEM              *
 ***************************************************/
	typedef file_kernel_caps_t file_linux_caps_t;

	extern int chcaps(const char *fname,
			  const file_linux_caps_t * linux_caps,
			  const file_mcbc_caps_t * mcbc_caps);
	extern int fchcaps(int fd, const file_linux_caps_t * linux_caps,
			   const file_mcbc_caps_t * mcbc_caps);
	extern int statcaps(const char *fname, file_linux_caps_t * linux_caps,
			    file_mcbc_caps_t * mcbc_caps);
	extern int fstatcaps(int fd, file_linux_caps_t * linux_caps,
			     file_mcbc_caps_t * mcbc_caps);

#ifdef __cplusplus
}
#endif
#endif				/* _ISS_CAPS_H_INCLUDED */
