/* $Id: file_audit.h 606 2008-08-15 08:39:26Z gloomy $ */

#ifndef _LINUX_FILE_AUDIT_H
#define _LINUX_FILE_AUDIT_H

#include <linux/types.h>

#include <parsec/parsec.h>
#include <parsec/parsec_aud.h>

/*
#define FS_LOG_OPEN    		(1<<0)
#define FS_LOG_EXEC    		(1<<1)
#define FS_LOG_DELETE  		(1<<2)
#define FS_LOG_CHMOD  		(1<<3)
#define FS_LOG_CHOWN  		(1<<4)
#define FS_LOG_AUDIT  		(1<<5)
#define FS_LOG_XATTR  		(1<<6)
#define FS_LOG_MAC  		(1<<7)
#define FS_LOG_CREATE  		(1<<8)	// create in dir
*/

typedef struct _file_audit_item {
	uint32_t success;
	uint32_t failed;
	uint8_t type;
	uint16_t id;
} file_audit_item_t;


/* types */
/*
#define FILE_AUDIT_REGULAR 0x0
#define FILE_AUDIT_DEFAULT 0x1
#define FILE_AUDIT_TYPES   0x2
*/

typedef struct _file_audit_header {
	uint8_t type;
	uint8_t flags;		// reserved
	uint16_t num;
	file_audit_item_t ids[1];
} file_audit_header_t;


//#define MAX_FILE_AUDIT_USER_SIZE 4096

/*
#define FILE_AUDIT_ANY 1
#define FILE_AUDIT_UID 2
#define FILE_AUDIT_GID 3
*/

//#define FILE_AUDIT_NONE    0x00
//#define FILE_AUDIT_UNKNOWN 0x0f

/*
#define FILE_AUDIT_TYPE  0x0f
#define FILE_AUDIT_FLAG  ~(FILE_AUDIT_TYPE)
*/
				    /* #define FILE_AUDIT_NOT   0x10 *//* legacy */

#endif
