/* $Id: file_caps.h 606 2008-08-15 08:39:26Z gloomy $ */

#ifndef _LINUX_FILE_CAPABILITY_H
#define _LINUX_FILE_CAPABILITY_H

#include <linux/types.h>

typedef struct _file_kernel_caps {
	uint32_t cap_permitted;
	uint32_t cap_inheritable;
} file_kernel_caps_t;

typedef struct _file_mcbc_caps {
	uint32_t cap_permitted;
	uint32_t cap_inheritable;
} file_mcbc_caps_t;

typedef struct _file_caps {
	unsigned long version;

	union {
		file_kernel_caps_t linux_caps;
		file_mcbc_caps_t mcbc_caps;
	} caps;
} file_caps_t;

#endif
