/* $Id: mac.h 606 2008-08-15 08:39:26Z gloomy $ */

#ifndef __MAC_H_INCLUDED
#define __MAC_H_INCLUDED

#include <parsec/parsec.h>
#include <parsec/parsec_mac.h>

#include <linux/types.h>

typedef struct _mac_label {
	uint8_t level;
	uint64_t category;		/* 64 bits */
} mac_label_t;

typedef struct _file_mac_label {
	uint32_t attr;
	mac_label_t mac;
} file_mac_label_t;
#define MCBC_LEVEL(label) ((label).level)
#define MCBC_CATEGORY(label) ((label).category)

#ifndef MAC_ATTR_IGNORER_CAT
#define MAC_ATTR_IGNORER_CAT   0x00000001
#endif

#ifndef MAC_ATTR_IGNOREW_CAT
#define MAC_ATTR_IGNOREW_CAT   0x00000002
#endif

#ifndef MAC_ATTR_IGNOREX_CAT
#define MAC_ATTR_IGNOREX_CAT   0x00000004
#endif

#ifndef MAC_ATTR_IGNORER_LVL
#define MAC_ATTR_IGNORER_LVL   0x00000008
#endif

#ifndef MAC_ATTR_IGNOREW_LVL
#define MAC_ATTR_IGNOREW_LVL   0x00000010
#endif

#ifndef MAC_ATTR_IGNOREX_LVL
#define MAC_ATTR_IGNOREX_LVL   0x00000020
#endif

#ifndef MAC_ATTR_IGNORER
#define MAC_ATTR_IGNORER  ((MAC_ATTR_IGNORER_CAT) | (MAC_ATTR_IGNORER_LVL))
#endif

#ifndef MAC_ATTR_IGNOREW
#define MAC_ATTR_IGNOREW  ((MAC_ATTR_IGNOREW_CAT) | (MAC_ATTR_IGNOREW_LVL))
#endif

#ifndef MAC_ATTR_IGNOREX
#define MAC_ATTR_IGNOREX  ((MAC_ATTR_IGNOREX_CAT) | (MAC_ATTR_IGNOREX_LVL))
#endif

#ifndef MAC_ATTR_IGNORE
#define MAC_ATTR_IGNORE ((MAC_ATTR_IGNORER) | (MAC_ATTR_IGNOREW) | (MAC_ATTR_IGNOREX))
#endif

#ifndef MAC_ATTR_CHECK
#define MAC_ATTR_CHECK(mac, a) ((mac).attr & MAC_ATTR_##a)
#endif

#ifndef MAC_MAX_LEVEL
#define MAC_MAX_LEVEL 255
#endif

#ifndef MAC_MAX_CATEGORY
#define MAC_MAX_CATEGORY ((uint64_t)(-1))
#endif

#endif // __MAC_H_INCLUDED
