/* $Id: mcbc_cap.h 606 2008-08-15 08:39:26Z gloomy $ */

#ifndef _MCBC_CAPABILITY_H
#define _MCBC_CAPABILITY_H

#include <linux/types.h>
#include <stdint.h>

#define MCBC_CAP_FILE_CAP  0	/* 1 */
#define MCBC_CAP_AUDIT     1	/* 2 */

#define MCBC_CAP_SETMAC    2	/* 4 */
#define MCBC_CAP_CHMAC     3	/* 8 */

#define MCBC_CAP_IGNMACLVL 4	/* 10 */
#define MCBC_CAP_IGNMACCAT 5	/* 20 */
#define MCBC_CAP_SIG       6	/* 40 */

#define MCBC_CAP_UPDATE_ATIME       7	/* 80 */

#define MCBC_CAP_PRIV_SOCK       8	/* 100 */

#define MCBC_CAP_READSEARCH      9	/* 200 */

#define MCBC_CAP_FS_MASK (CAP_TO_MASK(MCBC_CAP_FILE_CAP) | CAP_TO_MASK(MCBC_CAP_CHMAC) | CAP_TO_MASK(MCBC_CAP_IGNMACLVL) | CAP_TO_MASK(MCBC_CAP_IGNMACCAT) | CAP_TO_MASK(MCBC_CAP_UPDATE_ATIME) | CAP_TO_MASK(MCBC_CAP_READSEARCH))

#define _MCBC_CAPABILITY_VERSION  0x20021803
typedef struct _mcbc_caps {
	uint32_t effective;
	uint32_t permitted;
	uint32_t inheritable;
} mcbc_caps_t;
typedef mcbc_caps_t mcbc_cap_user_data_t;

#endif
